Merge branch 'master' of git://git.kernel.org/pub/scm/git/git
[git/jnareb-git.git] / t / test-lib.sh
blobdebd8b475186591ec1d1ef38848fef1a213889f4
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Keep the original TERM for say_color
19 ORIGINAL_TERM=$TERM
21 # Test the binaries we have just built. The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
24 then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
30 if test -z "$TEST_OUTPUT_DIRECTORY"
31 then
32 # Similarly, override this to store the test-results subdir
33 # elsewhere
34 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38 ################################################################
39 # It appears that people try to run tests without building...
40 "$GIT_BUILD_DIR/git" >/dev/null
41 if test $? != 1
42 then
43 echo >&2 'error: you do not seem to have built git yet.'
44 exit 1
47 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
48 export PERL_PATH SHELL_PATH
50 # if --tee was passed, write the output not only to the terminal, but
51 # additionally to the file test-results/$BASENAME.out, too.
52 case "$GIT_TEST_TEE_STARTED, $* " in
53 done,*)
54 # do not redirect again
56 *' --tee '*|*' --va'*)
57 mkdir -p test-results
58 BASE=test-results/$(basename "$0" .sh)
59 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
60 echo $? > $BASE.exit) | tee $BASE.out
61 test "$(cat $BASE.exit)" = 0
62 exit
64 esac
66 # For repeatability, reset the environment to known value.
67 LANG=C
68 LC_ALL=C
69 PAGER=cat
70 TZ=UTC
71 TERM=dumb
72 export LANG LC_ALL PAGER TERM TZ
73 EDITOR=:
74 # A call to "unset" with no arguments causes at least Solaris 10
75 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
76 # deriving from the command substitution clustered with the other
77 # ones.
78 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
79 my @env = keys %ENV;
80 my $ok = join("|", qw(
81 TRACE
82 DEBUG
83 USE_LOOKUP
84 TEST
85 .*_TEST
86 PROVE
87 VALGRIND
88 UNZIP
89 PERF_
90 ));
91 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
92 print join("\n", @vars);
94 unset XDG_CONFIG_HOME
95 GIT_AUTHOR_EMAIL=author@example.com
96 GIT_AUTHOR_NAME='A U Thor'
97 GIT_COMMITTER_EMAIL=committer@example.com
98 GIT_COMMITTER_NAME='C O Mitter'
99 GIT_MERGE_VERBOSITY=5
100 GIT_MERGE_AUTOEDIT=no
101 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
102 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
103 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
104 export EDITOR
106 # Add libc MALLOC and MALLOC_PERTURB test
107 # only if we are not executing the test with valgrind
108 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
109 test -n "$TEST_NO_MALLOC_CHECK"
110 then
111 setup_malloc_check () {
112 : nothing
114 teardown_malloc_check () {
115 : nothing
117 else
118 setup_malloc_check () {
119 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
120 export MALLOC_CHECK_ MALLOC_PERTURB_
122 teardown_malloc_check () {
123 unset MALLOC_CHECK_ MALLOC_PERTURB_
127 # Protect ourselves from common misconfiguration to export
128 # CDPATH into the environment
129 unset CDPATH
131 unset GREP_OPTIONS
132 unset UNZIP
134 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
135 1|2|true)
136 echo "* warning: Some tests will not work if GIT_TRACE" \
137 "is set as to trace on STDERR ! *"
138 echo "* warning: Please set GIT_TRACE to something" \
139 "other than 1, 2 or true ! *"
141 esac
143 # Convenience
145 # A regexp to match 5 and 40 hexdigits
146 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
147 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
149 # Zero SHA-1
150 _z40=0000000000000000000000000000000000000000
152 # Line feed
153 LF='
156 export _x05 _x40 _z40 LF
158 # Each test should start with something like this, after copyright notices:
160 # test_description='Description of this test...
161 # This test checks if command xyzzy does the right thing...
163 # . ./test-lib.sh
164 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
165 TERM=$ORIGINAL_TERM &&
166 export TERM &&
167 [ -t 1 ] &&
168 tput bold >/dev/null 2>&1 &&
169 tput setaf 1 >/dev/null 2>&1 &&
170 tput sgr0 >/dev/null 2>&1
171 ) &&
172 color=t
174 while test "$#" -ne 0
176 case "$1" in
177 -d|--d|--de|--deb|--debu|--debug)
178 debug=t; shift ;;
179 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
180 immediate=t; shift ;;
181 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
182 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
183 -h|--h|--he|--hel|--help)
184 help=t; shift ;;
185 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
186 verbose=t; shift ;;
187 -q|--q|--qu|--qui|--quie|--quiet)
188 # Ignore --quiet under a TAP::Harness. Saying how many tests
189 # passed without the ok/not ok details is always an error.
190 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
191 --with-dashes)
192 with_dashes=t; shift ;;
193 --no-color)
194 color=; shift ;;
195 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
196 valgrind=memcheck
197 shift ;;
198 --valgrind=*)
199 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
200 shift ;;
201 --tee)
202 shift ;; # was handled already
203 --root=*)
204 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
205 shift ;;
207 echo "error: unknown test option '$1'" >&2; exit 1 ;;
208 esac
209 done
211 test -n "$valgrind" && verbose=t
213 if test -n "$color"
214 then
215 say_color () {
217 TERM=$ORIGINAL_TERM
218 export TERM
219 case "$1" in
220 error)
221 tput bold; tput setaf 1;; # bold red
222 skip)
223 tput setaf 4;; # blue
224 warn)
225 tput setaf 3;; # brown/yellow
226 pass)
227 tput setaf 2;; # green
228 info)
229 tput setaf 6;; # cyan
231 test -n "$quiet" && return;;
232 esac
233 shift
234 printf "%s" "$*"
235 tput sgr0
236 echo
239 else
240 say_color() {
241 test -z "$1" && test -n "$quiet" && return
242 shift
243 printf "%s\n" "$*"
247 error () {
248 say_color error "error: $*"
249 GIT_EXIT_OK=t
250 exit 1
253 say () {
254 say_color info "$*"
257 test "${test_description}" != "" ||
258 error "Test script did not set test_description."
260 if test "$help" = "t"
261 then
262 echo "$test_description"
263 exit 0
266 exec 5>&1
267 exec 6<&0
268 if test "$verbose" = "t"
269 then
270 exec 4>&2 3>&1
271 else
272 exec 4>/dev/null 3>/dev/null
275 test_failure=0
276 test_count=0
277 test_fixed=0
278 test_broken=0
279 test_success=0
281 test_external_has_tap=0
283 die () {
284 code=$?
285 if test -n "$GIT_EXIT_OK"
286 then
287 exit $code
288 else
289 echo >&5 "FATAL: Unexpected exit with code $code"
290 exit 1
294 GIT_EXIT_OK=
295 trap 'die' EXIT
297 # The user-facing functions are loaded from a separate file so that
298 # test_perf subshells can have them too
299 . "$TEST_DIRECTORY/test-lib-functions.sh"
301 # You are not expected to call test_ok_ and test_failure_ directly, use
302 # the text_expect_* functions instead.
304 test_ok_ () {
305 test_success=$(($test_success + 1))
306 say_color "" "ok $test_count - $@"
309 test_failure_ () {
310 test_failure=$(($test_failure + 1))
311 say_color error "not ok $test_count - $1"
312 shift
313 echo "$@" | sed -e 's/^/# /'
314 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
317 test_known_broken_ok_ () {
318 test_fixed=$(($test_fixed+1))
319 say_color error "ok $test_count - $@ # TODO known breakage vanished"
322 test_known_broken_failure_ () {
323 test_broken=$(($test_broken+1))
324 say_color warn "not ok $test_count - $@ # TODO known breakage"
327 test_debug () {
328 test "$debug" = "" || eval "$1"
331 test_eval_ () {
332 # This is a separate function because some tests use
333 # "return" to end a test_expect_success block early.
334 eval </dev/null >&3 2>&4 "$*"
337 test_run_ () {
338 test_cleanup=:
339 expecting_failure=$2
340 test_eval_ "$1"
341 eval_ret=$?
343 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
344 then
345 setup_malloc_check
346 test_eval_ "$test_cleanup"
347 teardown_malloc_check
349 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
350 then
351 echo ""
353 return "$eval_ret"
356 test_skip () {
357 test_count=$(($test_count+1))
358 to_skip=
359 for skp in $GIT_SKIP_TESTS
361 case $this_test.$test_count in
362 $skp)
363 to_skip=t
364 break
365 esac
366 done
367 if test -z "$to_skip" && test -n "$test_prereq" &&
368 ! test_have_prereq "$test_prereq"
369 then
370 to_skip=t
372 case "$to_skip" in
374 of_prereq=
375 if test "$missing_prereq" != "$test_prereq"
376 then
377 of_prereq=" of $test_prereq"
380 say_color skip >&3 "skipping test: $@"
381 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
382 : true
385 false
387 esac
390 # stub; perf-lib overrides it
391 test_at_end_hook_ () {
395 test_done () {
396 GIT_EXIT_OK=t
398 if test -z "$HARNESS_ACTIVE"
399 then
400 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
401 mkdir -p "$test_results_dir"
402 base=${0##*/}
403 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
405 cat >>"$test_results_path" <<-EOF
406 total $test_count
407 success $test_success
408 fixed $test_fixed
409 broken $test_broken
410 failed $test_failure
415 if test "$test_fixed" != 0
416 then
417 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
419 if test "$test_broken" != 0
420 then
421 say_color warn "# still have $test_broken known breakage(s)"
423 if test "$test_broken" != 0 || test "$test_fixed" != 0
424 then
425 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
426 msg="remaining $test_remaining test(s)"
427 else
428 test_remaining=$test_count
429 msg="$test_count test(s)"
431 case "$test_failure" in
433 # Maybe print SKIP message
434 if test -n "$skip_all" && test $test_count -gt 0
435 then
436 error "Can't use skip_all after running some tests"
438 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
440 if test $test_external_has_tap -eq 0
441 then
442 if test $test_remaining -gt 0
443 then
444 say_color pass "# passed all $msg"
446 say "1..$test_count$skip_all"
449 test -d "$remove_trash" &&
450 cd "$(dirname "$remove_trash")" &&
451 rm -rf "$(basename "$remove_trash")"
453 test_at_end_hook_
455 exit 0 ;;
458 if test $test_external_has_tap -eq 0
459 then
460 say_color error "# failed $test_failure among $msg"
461 say "1..$test_count"
464 exit 1 ;;
466 esac
469 if test -n "$valgrind"
470 then
471 make_symlink () {
472 test -h "$2" &&
473 test "$1" = "$(readlink "$2")" || {
474 # be super paranoid
475 if mkdir "$2".lock
476 then
477 rm -f "$2" &&
478 ln -s "$1" "$2" &&
479 rm -r "$2".lock
480 else
481 while test -d "$2".lock
483 say "Waiting for lock on $2."
484 sleep 1
485 done
490 make_valgrind_symlink () {
491 # handle only executables, unless they are shell libraries that
492 # need to be in the exec-path. We will just use "#!" as a
493 # guess for a shell-script, since we have no idea what the user
494 # may have configured as the shell path.
495 test -x "$1" ||
496 test "#!" = "$(head -c 2 <"$1")" ||
497 return;
499 base=$(basename "$1")
500 symlink_target=$GIT_BUILD_DIR/$base
501 # do not override scripts
502 if test -x "$symlink_target" &&
503 test ! -d "$symlink_target" &&
504 test "#!" != "$(head -c 2 < "$symlink_target")"
505 then
506 symlink_target=../valgrind.sh
508 case "$base" in
509 *.sh|*.perl)
510 symlink_target=../unprocessed-script
511 esac
512 # create the link, or replace it if it is out of date
513 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
516 # override all git executables in TEST_DIRECTORY/..
517 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
518 mkdir -p "$GIT_VALGRIND"/bin
519 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
521 make_valgrind_symlink $file
522 done
523 # special-case the mergetools loadables
524 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
525 OLDIFS=$IFS
526 IFS=:
527 for path in $PATH
529 ls "$path"/git-* 2> /dev/null |
530 while read file
532 make_valgrind_symlink "$file"
533 done
534 done
535 IFS=$OLDIFS
536 PATH=$GIT_VALGRIND/bin:$PATH
537 GIT_EXEC_PATH=$GIT_VALGRIND/bin
538 export GIT_VALGRIND
539 GIT_VALGRIND_MODE="$valgrind"
540 export GIT_VALGRIND_MODE
541 elif test -n "$GIT_TEST_INSTALLED"
542 then
543 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
544 error "Cannot run git from $GIT_TEST_INSTALLED."
545 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
546 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
547 else # normal case, use ../bin-wrappers only unless $with_dashes:
548 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
549 if ! test -x "$git_bin_dir/git"
550 then
551 if test -z "$with_dashes"
552 then
553 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
555 with_dashes=t
557 PATH="$git_bin_dir:$PATH"
558 GIT_EXEC_PATH=$GIT_BUILD_DIR
559 if test -n "$with_dashes"
560 then
561 PATH="$GIT_BUILD_DIR:$PATH"
564 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
565 unset GIT_CONFIG
566 GIT_CONFIG_NOSYSTEM=1
567 GIT_ATTR_NOSYSTEM=1
568 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
570 if test -z "$GIT_TEST_CMP"
571 then
572 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
573 then
574 GIT_TEST_CMP="$DIFF -c"
575 else
576 GIT_TEST_CMP="$DIFF -u"
580 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
581 export GITPERLLIB
582 test -d "$GIT_BUILD_DIR"/templates/blt || {
583 error "You haven't built things yet, have you?"
586 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
587 then
588 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
589 export GITPYTHONLIB
590 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
591 error "You haven't built git_remote_helpers yet, have you?"
595 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
596 then
597 echo >&2 'You need to build test-chmtime:'
598 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
599 exit 1
602 # Test repository
603 test="trash directory.$(basename "$0" .sh)"
604 test -n "$root" && test="$root/$test"
605 case "$test" in
606 /*) TRASH_DIRECTORY="$test" ;;
607 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$test" ;;
608 esac
609 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
610 rm -fr "$test" || {
611 GIT_EXIT_OK=t
612 echo >&5 "FATAL: Cannot prepare test area"
613 exit 1
616 HOME="$TRASH_DIRECTORY"
617 export HOME
619 if test -z "$TEST_NO_CREATE_REPO"
620 then
621 test_create_repo "$test"
622 else
623 mkdir -p "$test"
625 # Use -P to resolve symlinks in our working directory so that the cwd
626 # in subprocesses like git equals our $PWD (for pathname comparisons).
627 cd -P "$test" || exit 1
629 this_test=${0##*/}
630 this_test=${this_test%%-*}
631 for skp in $GIT_SKIP_TESTS
633 case "$this_test" in
634 $skp)
635 say_color info >&3 "skipping test $this_test altogether"
636 skip_all="skip all tests in $this_test"
637 test_done
638 esac
639 done
641 # Provide an implementation of the 'yes' utility
642 yes () {
643 if test $# = 0
644 then
646 else
647 y="$*"
650 while echo "$y"
653 done
656 # Fix some commands on Windows
657 case $(uname -s) in
658 *MINGW*)
659 # Windows has its own (incompatible) sort and find
660 sort () {
661 /usr/bin/sort "$@"
663 find () {
664 /usr/bin/find "$@"
666 sum () {
667 md5sum "$@"
669 # git sees Windows-style pwd
670 pwd () {
671 builtin pwd -W
673 # no POSIX permissions
674 # backslashes in pathspec are converted to '/'
675 # exec does not inherit the PID
676 test_set_prereq MINGW
677 test_set_prereq NOT_CYGWIN
678 test_set_prereq SED_STRIPS_CR
680 *CYGWIN*)
681 test_set_prereq POSIXPERM
682 test_set_prereq EXECKEEPSPID
683 test_set_prereq NOT_MINGW
684 test_set_prereq CYGWIN
685 test_set_prereq SED_STRIPS_CR
688 test_set_prereq POSIXPERM
689 test_set_prereq BSLASHPSPEC
690 test_set_prereq EXECKEEPSPID
691 test_set_prereq NOT_MINGW
692 test_set_prereq NOT_CYGWIN
694 esac
696 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
697 test -z "$NO_PERL" && test_set_prereq PERL
698 test -z "$NO_PYTHON" && test_set_prereq PYTHON
699 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
700 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
702 # Can we rely on git's output in the C locale?
703 if test -n "$GETTEXT_POISON"
704 then
705 GIT_GETTEXT_POISON=YesPlease
706 export GIT_GETTEXT_POISON
707 test_set_prereq GETTEXT_POISON
708 else
709 test_set_prereq C_LOCALE_OUTPUT
712 # Use this instead of test_cmp to compare files that contain expected and
713 # actual output from git commands that can be translated. When running
714 # under GETTEXT_POISON this pretends that the command produced expected
715 # results.
716 test_i18ncmp () {
717 test -n "$GETTEXT_POISON" || test_cmp "$@"
720 # Use this instead of "grep expected-string actual" to see if the
721 # output from a git command that can be translated either contains an
722 # expected string, or does not contain an unwanted one. When running
723 # under GETTEXT_POISON this pretends that the command produced expected
724 # results.
725 test_i18ngrep () {
726 if test -n "$GETTEXT_POISON"
727 then
728 : # pretend success
729 elif test "x!" = "x$1"
730 then
731 shift
732 ! grep "$@"
733 else
734 grep "$@"
738 test_lazy_prereq PIPE '
739 # test whether the filesystem supports FIFOs
740 rm -f testfifo && mkfifo testfifo
743 test_lazy_prereq SYMLINKS '
744 # test whether the filesystem supports symbolic links
745 ln -s x y && test -h y
748 test_lazy_prereq CASE_INSENSITIVE_FS '
749 echo good >CamelCase &&
750 echo bad >camelcase &&
751 test "$(cat CamelCase)" != good
754 test_lazy_prereq UTF8_NFD_TO_NFC '
755 # check whether FS converts nfd unicode to nfc
756 auml=$(printf "\303\244")
757 aumlcdiar=$(printf "\141\314\210")
758 >"$auml" &&
759 case "$(echo *)" in
760 "$aumlcdiar")
761 true ;;
763 false ;;
764 esac
767 test_lazy_prereq AUTOIDENT '
768 sane_unset GIT_AUTHOR_NAME &&
769 sane_unset GIT_AUTHOR_EMAIL &&
770 git var GIT_AUTHOR_IDENT
773 # When the tests are run as root, permission tests will report that
774 # things are writable when they shouldn't be.
775 test -w / || test_set_prereq SANITY
777 GIT_UNZIP=${GIT_UNZIP:-unzip}
778 test_lazy_prereq UNZIP '
779 "$GIT_UNZIP" -v
780 test $? -ne 127